'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodashObjectAssign = require('lodash/object/assign');

var _lodashObjectAssign2 = _interopRequireDefault(_lodashObjectAssign);

var _Icon = require('./Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _reactPureRenderFunction = require('react-pure-render/function');

var _reactPureRenderFunction2 = _interopRequireDefault(_reactPureRenderFunction);

var _utilsMatterBasics = require('../utils/MatterBasics');

var _utilsMatterBasics2 = _interopRequireDefault(_utilsMatterBasics);

var _TooltipHOC = require('./TooltipHOC');

var _TooltipHOC2 = _interopRequireDefault(_TooltipHOC);

var Button = (function (_React$Component) {
  _inherits(Button, _React$Component);

  _createClass(Button, null, [{
    key: 'propTypes',
    value: {
      label: _react.PropTypes.string,
      icon: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.shape(_Icon2['default'].propTypes)]),
      onClick: _react.PropTypes.func,
      disabled: _react.PropTypes.bool,
      mod: _react.PropTypes.shape({
        kind: _react.PropTypes.oneOf(['normal', 'stamp', 'colored'])
      }),
      style: _react.PropTypes.object
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      label: '',
      disabled: false,
      mod: {
        kind: 'normal'
      }
    },
    enumerable: true
  }]);

  function Button(props) {
    var _this = this;

    _classCallCheck(this, _Button);

    _get(Object.getPrototypeOf(_Button.prototype), 'constructor', this).call(this, props);

    this.shouldComponentUpdate = _reactPureRenderFunction2['default'];

    this.handleClick = function () {
      var _props = _this.props;
      var onClick = _props.onClick;
      var disabled = _props.disabled;

      if (onClick && !disabled) {
        onClick();
      }
    };

    this.state = {
      toggled: false
    };
  }

  _createClass(Button, [{
    key: 'render',
    value: function render() {
      var _props2 = this.props;
      var mod = _props2.mod;
      var style = _props2.style;
      var icon = _props2.icon;
      var label = _props2.label;
      var disabled = _props2.disabled;

      mod = _extends({}, mod, { disabled: disabled, onlyIcon: icon && !label });

      if (typeof icon === 'string') {
        icon = { icon: icon };
      }

      if (icon) {
        var iconStyle = _extends({}, icon.style, { marginRight: label ? 4 : 0 });
        icon = _react2['default'].createElement(_Icon2['default'], _extends({}, icon, { style: iconStyle }));
      }

      return _react2['default'].createElement(
        'div',
        _extends({}, this.getBasics(), {
          style: this.getStyle('button', mod, style),
          onClick: this.handleClick }),
        icon,
        label
      );
    }
  }]);

  var _Button = Button;
  Button = (0, _utilsMatterBasics2['default'])(Button) || Button;
  Button = (0, _radium2['default'])(Button) || Button;
  Button = (0, _TooltipHOC2['default'])(Button) || Button;
  return Button;
})(_react2['default'].Component);

exports['default'] = Button;
module.exports = exports['default'];
//# sourceMappingURL=Button.js.map