'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _tinycolor2 = require('tinycolor2');

var _tinycolor22 = _interopRequireDefault(_tinycolor2);

var _Input = require('./Input');

var _Input2 = _interopRequireDefault(_Input);

var _utilsColorCircle = require('../utils/ColorCircle');

var _utilsColorCircle2 = _interopRequireDefault(_utilsColorCircle);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _reactPureRenderFunction = require('react-pure-render/function');

var _reactPureRenderFunction2 = _interopRequireDefault(_reactPureRenderFunction);

var _utilsMatterBasics = require('../utils/MatterBasics');

var _utilsMatterBasics2 = _interopRequireDefault(_utilsMatterBasics);

var FORMATS = ['prgb', 'hex6', 'hex3', 'hex8', 'name', 'hsl', 'hsv'];
//TODO customiseable formats

var ColorInput = (function (_React$Component) {
  _inherits(ColorInput, _React$Component);

  _createClass(ColorInput, null, [{
    key: 'propTypes',
    value: {},
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      value: '#000000'
    },
    enumerable: true
  }]);

  function ColorInput(props) {
    _classCallCheck(this, _ColorInput);

    _get(Object.getPrototypeOf(_ColorInput.prototype), 'constructor', this).call(this, props);

    this.shouldComponentUpdate = _reactPureRenderFunction2['default'];
    var value = props.value;

    this.state = {
      value: value,
      format: (0, _tinycolor22['default'])(value).getFormat()
    };
  }

  _createClass(ColorInput, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var value = nextProps.value;

      this.setState({
        value: value,
        format: (0, _tinycolor22['default'])(value).getFormat()
      });
    }
  }, {
    key: 'getCurrTypeIdx',
    value: function getCurrTypeIdx(props) {

      props = props || this.props;

      var _props = props;
      var typeIdx = _props.typeIdx;
      var chooseType = _props.chooseType;
      var value = _props.value;

      return chooseType ? chooseType(value) : defaultTypeIdx;
    }
  }, {
    key: 'handleChange',
    value: function handleChange(value) {

      this.setState({
        value: value,
        format: (0, _tinycolor22['default'])(value).getFormat()
      });

      if (this.props.onChange) {
        this.props.onChange(value);
      }
    }
  }, {
    key: 'stepFormat',
    value: function stepFormat() {

      var idx = FORMATS.indexOf(this.state.format) + 1;
      idx %= FORMATS.length;

      var format = FORMATS[idx];
      var value = (0, _tinycolor22['default'])(this.state.value).toString(format);

      this.setState({ value: value, format: format });
    }
  }, {
    key: 'renderSelector',
    value: function renderSelector() {

      // if (!this.state.focus) return null

      var hsl = (0, _tinycolor22['default'])(this.state.value).toHsl();

      return _react2['default'].createElement(
        'div',
        { style: {
            position: 'absolute',
            zIndex: 1,
            top: 32,
            left: 0,
            width: '100%'
          } },
        _react2['default'].createElement(_utilsColorCircle2['default'], _extends({}, hsl, {
          width: 28,
          radius: 64 }))
      );
    }
  }, {
    key: 'render',
    value: function render() {

      return _react2['default'].createElement(
        'span',
        null,
        _react2['default'].createElement(_Input2['default'], _extends({}, this.getBasics(), this.props, {
          value: this.state.value,
          addonIcon: 'adjust',
          onChange: this.handleChange,
          onInitialFormat: this.handleChange })),
        this.renderSelector()
      );
    }
  }]);

  var _ColorInput = ColorInput;
  ColorInput = (0, _utilsMatterBasics2['default'])(ColorInput) || ColorInput;
  ColorInput = (0, _radium2['default'])(ColorInput) || ColorInput;
  return ColorInput;
})(_react2['default'].Component);

exports['default'] = ColorInput;
module.exports = exports['default'];
//# sourceMappingURL=ColorInput.js.map