'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodashCollectionFind = require('lodash/collection/find');

var _lodashCollectionFind2 = _interopRequireDefault(_lodashCollectionFind);

var _lodashObjectAssign = require('lodash/object/assign');

var _lodashObjectAssign2 = _interopRequireDefault(_lodashObjectAssign);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _reactPureRenderFunction = require('react-pure-render/function');

var _reactPureRenderFunction2 = _interopRequireDefault(_reactPureRenderFunction);

var _utilsMatterBasics = require('../utils/MatterBasics');

var _utilsMatterBasics2 = _interopRequireDefault(_utilsMatterBasics);

var _utilsClickAway = require('../utils/ClickAway');

var _utilsClickAway2 = _interopRequireDefault(_utilsClickAway);

var _Icon = require('./Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _ListItem = require('./ListItem');

var _ListItem2 = _interopRequireDefault(_ListItem);

var _Label = require('./Label');

var _Label2 = _interopRequireDefault(_Label);

var _scrollableScrollable = require('./scrollable/Scrollable');

var _scrollableScrollable2 = _interopRequireDefault(_scrollableScrollable);

function renderItems(_ref) {
  var options = _ref.options;
  var onChange = _ref.onChange;
  var collapse = _ref.collapse;

  return _react2['default'].createElement(
    _scrollableScrollable2['default'],
    null,
    _react2['default'].createElement(
      'div',
      null,
      options.map(function (option, idx) {

        if (typeof option === 'string') {
          option = { label: option, value: option };
        }

        return _react2['default'].createElement(_ListItem2['default'], {
          key: idx,
          label: option.label,
          value: option.value,
          onClick: function () {
            if (onChange) {
              onChange(option.value);
            }

            if (option.onClick) {
              option.onClick(option.value);
            }

            collapse();
          } });
      })
    )
  );
}

var Dropdown = (function (_React$Component) {
  _inherits(Dropdown, _React$Component);

  _createClass(Dropdown, null, [{
    key: 'propTypes',
    value: {
      options: _react.PropTypes.arrayOf(_react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.shape({
        label: _react.PropTypes.string.isRequired,
        value: _react.PropTypes.any
      })])),
      renderContent: _react.PropTypes.func
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      options: [],
      renderContent: renderItems
    },
    enumerable: true
  }]);

  function Dropdown(props) {
    var _this = this;

    _classCallCheck(this, _Dropdown);

    _get(Object.getPrototypeOf(_Dropdown.prototype), 'constructor', this).call(this, props);

    this.shouldComponentUpdate = _reactPureRenderFunction2['default'];

    this.handleClickHead = function () {
      _this.setState({ open: !_this.state.open });
    };

    this.handleClickAway = function () {
      if (_this.state.open) {
        _this.setState({ open: false });
      }
    };

    this.state = {
      open: false
    };
  }

  _createClass(Dropdown, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props;
      var value = _props.value;
      var options = _props.options;
      var onChange = _props.onChange;
      var renderContent = _props.renderContent;
      var _props2 = this.props;
      var label = _props2.label;
      var mod = _props2.mod;
      var style = _props2.style;
      var open = this.state.open;

      var _getStyle = this.getStyle('config');

      var lineHeight = _getStyle.lineHeight;

      var collapse = function collapse() {
        return _this2.setState({ open: false });
      };

      if (label === undefined) {
        var currentOption = (0, _lodashCollectionFind2['default'])(options, { value: value });
        label = currentOption && currentOption.label;
      }

      mod = _extends({}, mod, { open: open });

      if (open) {
        style = (0, _lodashObjectAssign2['default'])({
          height: lineHeight * (this.props.options.length + 1)
        }, style);
      }

      return _react2['default'].createElement(
        _utilsClickAway2['default'],
        { onClickAway: this.handleClickAway },
        _react2['default'].createElement(
          'div',
          _extends({
            title: label
          }, this.getBasics(), {
            style: this.getStyle('dropdown', mod, _extends({ maxHeight: 246 }, style)) }),
          _react2['default'].createElement(
            'div',
            {
              style: { paddingLeft: 8, paddingRight: 8, display: 'flex' },
              onClick: this.handleClickHead },
            _react2['default'].createElement(
              _Label2['default'],
              { style: { flex: 1 } },
              label
            ),
            _react2['default'].createElement(_Icon2['default'], {
              style: { marginLeft: 4 },
              icon: open ? 'chevron-up' : 'chevron-down' })
          ),
          open && renderContent({ options: options, onChange: onChange, collapse: collapse })
        )
      );
    }
  }]);

  var _Dropdown = Dropdown;
  Dropdown = (0, _utilsMatterBasics2['default'])(Dropdown) || Dropdown;
  Dropdown = (0, _radium2['default'])(Dropdown) || Dropdown;
  return Dropdown;
})(_react2['default'].Component);

exports['default'] = Dropdown;
module.exports = exports['default'];
//# sourceMappingURL=Dropdown.js.map