'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _lodashLangIsFinite = require('lodash/lang/isFinite');

var _lodashLangIsFinite2 = _interopRequireDefault(_lodashLangIsFinite);

var _Icon = require('./Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _List = require('./List');

var _List2 = _interopRequireDefault(_List);

var _Panel = require('./Panel');

var _Panel2 = _interopRequireDefault(_Panel);

var _customDrag = require('custom-drag');

var _customDrag2 = _interopRequireDefault(_customDrag);

var _fuzzy = require('fuzzy');

var _fuzzy2 = _interopRequireDefault(_fuzzy);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _reactPureRenderFunction = require('react-pure-render/function');

var _reactPureRenderFunction2 = _interopRequireDefault(_reactPureRenderFunction);

var _tinycolor2 = require('tinycolor2');

var _tinycolor22 = _interopRequireDefault(_tinycolor2);

var _utilsMatterBasics = require('../utils/MatterBasics');

var _utilsMatterBasics2 = _interopRequireDefault(_utilsMatterBasics);

var _utilsColorCircle = require('../utils/ColorCircle');

var _utilsColorCircle2 = _interopRequireDefault(_utilsColorCircle);

var dragOptions = {
  onDown: function onDown(props, monitor, component) {
    // monitor.getLastEvent().stopPropagation()
    if (!component.isDraggable()) {
      return false;
    }

    monitor.setData({
      onDownValue: component.state.formattedValue
    });
  },
  onDrag: function onDrag(props, monitor, component) {
    var _monitor$getData = monitor.getData();

    var onDownValue = _monitor$getData.onDownValue;

    var _monitor$getDifferenceFromInitialOffset = monitor.getDifferenceFromInitialOffset();

    var x = _monitor$getDifferenceFromInitialOffset.x;

    var value = onDownValue + x * props.dragSpeed;
    component.editValue(value);
  },
  onClick: function onClick(ptops, monitor, component) {
    var node = _reactDom2['default'].findDOMNode(component).querySelector('input');
    node.focus();
    node.select();
  }
};

var Input = (function (_React$Component) {
  _inherits(Input, _React$Component);

  _createClass(Input, null, [{
    key: 'propTypes',
    value: {
      value: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string]),
      type: _react.PropTypes.oneOf(['string', 'number', 'color'])
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      disabled: false,
      draggable: true,
      precision: 12,
      dragSpeed: 1,
      value: '',
      type: 'string',
      min: undefined,
      max: undefined,
      prepareExportValue: undefined,
      formatValue: undefined,

      hints: undefined,
      maxVisibleHints: 12
    },
    enumerable: true
  }]);

  function Input(props) {
    var _this = this;

    _classCallCheck(this, _Input);

    _get(Object.getPrototypeOf(_Input.prototype), 'constructor', this).call(this, props);

    this.shouldComponentUpdate = _reactPureRenderFunction2['default'];

    this.handleInputRef = function (component) {
      _this.inputNode = _reactDom2['default'].findDOMNode(component);
    };

    this.triggerBlur = function () {
      _this.inputNode.blur();
    };

    this.handleChange = function (e) {
      _this.setState({
        inputValue: e.target.value
      });
    };

    this.handleFocus = function () {
      _this.setState({
        inputValue: _this.state.formattedValue,
        focus: true
      });
      _this.showDropdown();
    };

    this.handleBlur = function () {
      _this.editValue(_this.state.inputValue);

      _this.setState({
        focus: false
      });
      _this.hideDropdown();
    };

    this.handleKeyPress = function (e) {
      if (e.which === 13) {
        _this.triggerBlur();
      }
    };

    this.state = {
      error: false
    };
  }

  _createClass(Input, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.setPropsValue(this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setPropsValue(nextProps);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      var _state = this.state;
      var exportValue = _state.exportValue;
      var focus = _state.focus;

      if (!focus && exportValue !== prevState.exportValue && exportValue !== this.props.value && this.props.onChange) {
        this.props.onChange(exportValue);
      }
    }
  }, {
    key: 'isDraggable',
    value: function isDraggable() {
      return this.props.type === 'number' && this.props.draggable && !this.state.focus;
    }
  }, {
    key: 'setPropsValue',
    value: function setPropsValue(props) {
      if (!this.state.focus) {
        this.editValue(props.value, props);
      }
    }
  }, {
    key: 'editValue',
    value: function editValue(value, props) {
      props = props || this.props;
      var _props = props;
      var prepareExportValue = _props.prepareExportValue;

      var formattedValue = this.formatValue(value, props);
      var prettifiedValue = this.prettifyValue(formattedValue, props);
      var exportValue = prepareExportValue ? prepareExportValue(formattedValue) : formattedValue;

      this.setState({ formattedValue: formattedValue, prettifiedValue: prettifiedValue, exportValue: exportValue });

      this.validate(formattedValue);
    }
  }, {
    key: 'formatValue',
    value: function formatValue(value, props) {
      props = props || this.props;

      if (props.type === 'number') {
        value = this.formatNumber(value);
      } else if (props.type === 'string') {
        value += '';
      }

      if (props.formatValue) {
        value = props.formatValue(value);
      }

      return value;
    }
  }, {
    key: 'formatNumber',
    value: function formatNumber(value) {
      var _props2 = this.props;
      var min = _props2.min;
      var max = _props2.max;

      value = parseFloat(value);
      if ((0, _lodashLangIsFinite2['default'])(min)) value = Math.max(min, value);
      if ((0, _lodashLangIsFinite2['default'])(max)) value = Math.min(max, value);

      return (0, _lodashLangIsFinite2['default'])(value) ? value : 0;
    }
  }, {
    key: 'prettifyValue',
    value: function prettifyValue(value, props) {
      props = props || this.props;

      if (props.type === 'number') {
        value = this.prettifyNumber(value);
      }

      if (props.prettifyValue) {
        value = props.prettifyValue(value);
      }

      return value;
    }
  }, {
    key: 'prettifyNumber',
    value: function prettifyNumber(value) {
      var precision = this.props.precision;

      value = parseFloat(value.toFixed(precision));
      return value;
    }
  }, {
    key: 'validate',
    value: function validate(value) {
      var _props3 = this.props;
      var validate = _props3.validate;
      var type = _props3.type;

      if (typeof validate === 'function') {
        this.setState({ error: !this.props.validate(value) });
      } else if (type === 'color') {
        this.setState({ error: !(0, _tinycolor22['default'])(value).isValid() });
      }
    }
  }, {
    key: 'forceShowDropdown',
    value: function forceShowDropdown() {
      this.setState({
        forceShowDropdown: true,
        showDropdown: true
      });
    }
  }, {
    key: 'showDropdown',
    value: function showDropdown() {
      this.setState({
        showDropdown: true
      });
    }
  }, {
    key: 'hideDropdown',
    value: function hideDropdown() {
      this.setState({
        forceShowDropdown: false,
        showDropdown: false
      });
    }
  }, {
    key: 'renderHints',
    value: function renderHints() {
      var _this2 = this;

      var hints = this.props.hints;
      var _state2 = this.state;
      var inputValue = _state2.inputValue;
      var lastlySelectedHint = _state2.lastlySelectedHint;
      var forceShowDropdown = _state2.forceShowDropdown;

      if (!forceShowDropdown && (inputValue === lastlySelectedHint || !inputValue || !hints)) {
        return null;
      }

      var selectedHints = _fuzzy2['default'].filter(inputValue || '', hints, {
        pre: '<strong>',
        post: '</strong>'
      }).slice(0, 12).map(function (hint) {
        return {
          label: _react2['default'].createElement('span', { dangerouslySetInnerHTML: { __html: hint.string } }),
          onClick: function onClick(e) {
            var value = hint.original;
            _this2.setState({
              inputValue: value,
              lastlySelectedHint: value
            }, _this2.triggerBlur);
            // this.editValue(value)
            _this2.hideDropdown();
          }
        };
      });

      if (selectedHints.length === 0) {
        return null;
      }

      return _react2['default'].createElement(_List2['default'], { items: selectedHints });
    }
  }, {
    key: 'renderColorCircle',
    value: function renderColorCircle() {
      var _this3 = this;

      var handleChange = function handleChange(hsl) {
        hsl = _extends({}, hsl, { h: 360 * hsl.h });
        var color = (0, _tinycolor22['default'])(_this3.state.inputValue);
        var format = color.getFormat();
        var alpha = color.getAlpha();
        var value = (0, _tinycolor22['default'])(hsl).setAlpha(alpha).toString(format);
        _this3.setState({
          inputValue: value
        });
        _this3.editValue(value);
      };

      var inputColor = (0, _tinycolor22['default'])(this.state.inputValue);
      var hsl = inputColor.isValid() ? inputColor.toHsl() : { h: 0, s: 0.5, l: 0.5 };
      var radius = 234;

      return _react2['default'].createElement(_utilsColorCircle2['default'], {
        h: hsl.h / 360,
        s: hsl.s,
        l: hsl.l,
        radius: radius,
        width: radius * 0.16,
        onChange: handleChange });
    }
  }, {
    key: 'renderDropdown',
    value: function renderDropdown() {
      if (!this.state.showDropdown) {
        return null;
      }

      var type = this.props.type;

      var content = type === 'string' ? this.renderHints() : type === 'color' ? this.renderColorCircle() : null;

      if (!content) {
        return null;
      }

      return _react2['default'].createElement(
        _Panel2['default'],
        {
          style: {
            position: 'absolute',
            zIndex: 1000,
            top: '100%',
            left: 0,
            width: '100%'
          },
          onMouseDown: function (e) {
            e.preventDefault();
            e.stopPropagation();
          } },
        content
      );
    }
  }, {
    key: 'renderAddon',
    value: function renderAddon() {
      var _this4 = this;

      var _props4 = this.props;
      var mod = _props4.mod;
      var addonIcon = _props4.addonIcon;
      var addonLabel = _props4.addonLabel;
      var addonBackground = _props4.addonBackground;
      var addonOnClick = _props4.addonOnClick;

      return _react2['default'].createElement(Addon, {
        mod: mod,
        icon: addonIcon,
        label: addonLabel,
        background: addonBackground,
        onClick: addonOnClick === 'show-dropdown' ? function () {
          return _this4.forceShowDropdown();
        } : addonOnClick });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props5 = this.props;
      var mod = _props5.mod;
      var style = _props5.style;
      var pattern = _props5.pattern;
      var placeholder = _props5.placeholder;
      var disabled = _props5.disabled;
      var dragRef = _props5.dragRef;
      var _state3 = this.state;
      var focus = _state3.focus;
      var inputValue = _state3.inputValue;
      var prettifiedValue = _state3.prettifiedValue;
      var error = _state3.error;

      var draggable = this.isDraggable();

      return _react2['default'].createElement(
        'div',
        {
          style: this.getStyle('input', _extends({ error: error }, mod), style),
          onMouseDown: this.handleMouseDown },
        _react2['default'].createElement('input', _extends({
          ref: dragRef(this.handleInputRef)
        }, this.getBasics(), {
          style: this.getStyle('inputField', _extends({ draggable: draggable }, mod)),
          palceholder: placeholder,
          value: focus ? inputValue : prettifiedValue,
          type: 'text',
          name: this.props.name,
          pattern: pattern,
          onFocus: this.handleFocus,
          onBlur: this.handleBlur,
          onChange: this.handleChange,
          onKeyPress: this.handleKeyPress,
          disabled: disabled })),
        this.renderAddon(),
        this.renderDropdown()
      );
    }
  }]);

  var _Input = Input;
  Input = (0, _utilsMatterBasics2['default'])(Input) || Input;
  Input = (0, _radium2['default'])(Input) || Input;
  Input = (0, _customDrag2['default'])(dragOptions, function (connect) {
    return {
      dragRef: connect.getDragRef()
    };
  })(Input) || Input;
  return Input;
})(_react2['default'].Component);

exports['default'] = Input;

var Addon = (function (_React$Component2) {
  _inherits(Addon, _React$Component2);

  function Addon() {
    _classCallCheck(this, _Addon);

    _get(Object.getPrototypeOf(_Addon.prototype), 'constructor', this).apply(this, arguments);

    this.shouldComponentUpdate = _reactPureRenderFunction2['default'];
  }

  _createClass(Addon, [{
    key: 'render',
    value: function render() {
      var _props6 = this.props;
      var label = _props6.label;
      var icon = _props6.icon;
      var mod = _props6.mod;
      var onClick = _props6.onClick;

      if (!label && !icon) {
        return _react2['default'].createElement('div', { hidden: true });
      }

      icon = icon ? _react2['default'].createElement(_Icon2['default'], { icon: icon }) : undefined;

      return _react2['default'].createElement(
        'span',
        _extends({}, this.getBasics(), {
          style: this.getStyle('inputAddon', mod),
          onClick: onClick }),
        label,
        icon
      );
    }
  }]);

  var _Addon = Addon;
  Addon = (0, _utilsMatterBasics2['default'])(Addon) || Addon;
  Addon = (0, _radium2['default'])(Addon) || Addon;
  return Addon;
})(_react2['default'].Component);

module.exports = exports['default'];
//# sourceMappingURL=Input.js.map