'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _utilsCustomDrag = require('../utils/CustomDrag');

var _utilsCustomDrag2 = _interopRequireDefault(_utilsCustomDrag);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _reactPureRenderFunction = require('react-pure-render/function');

var _reactPureRenderFunction2 = _interopRequireDefault(_reactPureRenderFunction);

var _utilsMatterBasics = require('../utils/MatterBasics');

var _utilsMatterBasics2 = _interopRequireDefault(_utilsMatterBasics);

var Slider = (function (_React$Component) {
  _inherits(Slider, _React$Component);

  _createClass(Slider, null, [{
    key: 'propTypes',
    value: {},
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      min: -100,
      max: 100,
      value: 0
    },
    enumerable: true
  }]);

  function Slider(props) {
    _classCallCheck(this, _Slider);

    _get(Object.getPrototypeOf(_Slider.prototype), 'constructor', this).call(this, props);

    this.shouldComponentUpdate = _reactPureRenderFunction2['default'];
    this.state = { dragging: false };
  }

  _createClass(Slider, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this = this;

      new _utilsCustomDrag2['default']({
        deTarget: _reactDom2['default'].findDOMNode(this.refs.handle),
        onDown: function onDown() {
          return {
            value: _this.props.value,
            width: _reactDom2['default'].findDOMNode(_this).offsetWidth
          };
        },
        onDrag: function onDrag(md) {

          _this.setState({ dragging: true });

          var range = _this.props.max - _this.props.min,
              value = md.value + md.dx / md.width * range;

          _this.props.onChange(value);
        },
        onUp: function onUp() {
          _this.setState({ dragging: false });
        }
      });
    }
  }, {
    key: 'render',
    value: function render() {

      var width = this.isMounted() ? _reactDom2['default'].findDOMNode(this).offsetWidth : 0,
          range = this.props.max - this.props.min,
          progress = (this.props.value - this.props.min) / range,
          percent = Math.max(0, Math.min(1, progress)) * 100 + '%';

      return _react2['default'].createElement(
        'div',
        { style: style.slider,
          onMouseDown: function (e) {
            return e.preventDefault();
          } },
        _react2['default'].createElement(Handle, { ref: 'handle', left: percent, dragging: this.state.dragging }),
        _react2['default'].createElement(
          'div',
          { style: style.sliderBarBg },
          _react2['default'].createElement('div', { ref: 'progress', style: _.defaults({ width: percent }, style.sliderBarProgress) })
        )
      );
    }
  }]);

  var _Slider = Slider;
  Slider = (0, _utilsMatterBasics2['default'])(Slider) || Slider;
  Slider = (0, _radium2['default'])(Slider) || Slider;
  return Slider;
})(_react2['default'].Component);

exports['default'] = Slider;

var Handle = (function (_React$Component2) {
  _inherits(Handle, _React$Component2);

  function Handle() {
    _classCallCheck(this, Handle);

    _get(Object.getPrototypeOf(Handle.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(Handle, [{
    key: 'getInitialState',
    value: function getInitialState() {
      return {
        hover: false,
        down: false
      };
    }
  }, {
    key: 'onMouseUp',
    value: function onMouseUp() {
      this.setState({ down: false });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      window.addEventListener('mouseup', this.onMouseUp);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('mouseup', this.onMouseUp);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var s;

      if (this.state.down || this.props.dragging) s = style.sliderHandleActive;else if (this.state.hover) s = style.sliderHandleHover;else s = style.sliderHandle;

      return _react2['default'].createElement('div', { style: _.defaults({ left: this.props.left }, s),
        onMouseEnter: function () {
          return _this2.setState({ hover: true });
        },
        onMouseLeave: function () {
          return _this2.setState({ hover: false });
        },
        onMouseDown: function () {
          return _this2.setState({ down: true });
        } });
    }
  }]);

  return Handle;
})(_react2['default'].Component);

exports['default'] = Handle;
module.exports = exports['default'];
//# sourceMappingURL=Slider.js.map