'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodashObjectHas = require('lodash/object/has');

var _lodashObjectHas2 = _interopRequireDefault(_lodashObjectHas);

var _lodashObjectAssign = require('lodash/object/assign');

var _lodashObjectAssign2 = _interopRequireDefault(_lodashObjectAssign);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _reactPureRenderFunction = require('react-pure-render/function');

var _reactPureRenderFunction2 = _interopRequireDefault(_reactPureRenderFunction);

var _utilsMatterBasics = require('../utils/MatterBasics');

var _utilsMatterBasics2 = _interopRequireDefault(_utilsMatterBasics);

var Toggle = (function (_React$Component) {
  _inherits(Toggle, _React$Component);

  _createClass(Toggle, null, [{
    key: 'propTypes',
    value: {
      labelLeft: _react2['default'].PropTypes.string,
      valueLeft: _react2['default'].PropTypes.any,
      labelRight: _react2['default'].PropTypes.string,
      valueRight: _react2['default'].PropTypes.any
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      valueLeft: true,
      valueRight: false,
      labelLeft: 'ON',
      labelRight: 'OFF'
    },
    enumerable: true
  }]);

  function Toggle(props) {
    _classCallCheck(this, _Toggle);

    _get(Object.getPrototypeOf(_Toggle.prototype), 'constructor', this).call(this, props);

    this.shouldComponentUpdate = _reactPureRenderFunction2['default'];
    var defaultValue = props.defaultValue;
    var valueRight = props.valueRight;

    this.state = {
      left: defaultValue === valueRight ? false : true
    };
  }

  _createClass(Toggle, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {

      if ((0, _lodashObjectHas2['default'])(nextProps, 'defaultValue')) {
        var _props = this.props;
        var defaultValue = _props.defaultValue;
        var valueLeft = _props.valueLeft;
        var valueRight = _props.valueRight;

        var left = undefined;

        if (defaultValue === valueLeft) left = true;else if (defaultValue === valueRight) left = false;

        if (left !== undefined) {
          this.setState({ left: left });
        }
      }
    }
  }, {
    key: 'renderSide',
    value: function renderSide(label, on, side) {
      var mod = (0, _lodashObjectAssign2['default'])({ on: on, side: side }, this.props.mod);

      return _react2['default'].createElement(
        'div',
        { style: this.getStyle('toggleSide', mod) },
        label
      );
    }
  }, {
    key: 'renderKnob',
    value: function renderKnob(left) {
      var mod = (0, _lodashObjectAssign2['default'])({ onLeft: left ? 'true' : 'false' }, this.props.mod);

      return _react2['default'].createElement(
        'div',
        { style: this.getStyle('toggleKnob', mod) },
        this.renderGrip()
      );
    }
  }, {
    key: 'renderGrip',
    value: function renderGrip() {
      var grey = 'white';

      return _react2['default'].createElement(
        'svg',
        { width: '32', height: '32' },
        _react2['default'].createElement('line', { x1: '13.5', y1: '12', x2: '13.5', y2: '20', stroke: grey, strokeWidth: '1' }),
        _react2['default'].createElement('line', { x1: '15.5', y1: '12', x2: '15.5', y2: '20', stroke: grey, strokeWidth: '1' }),
        _react2['default'].createElement('line', { x1: '17.5', y1: '12', x2: '17.5', y2: '20', stroke: grey, strokeWidth: '1' })
      );
    }
  }, {
    key: 'handleClick',
    value: function handleClick() {

      var left = !this.state.left;

      if (this.props.onChange) {
        var value = left ? this.props.valueLeft : this.props.valueRight;
        this.props.onChange(value);
      }

      this.setState({ left: left });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this = this;

      var _props2 = this.props;
      var mod = _props2.mod;
      var style = _props2.style;
      var labelLeft = _props2.labelLeft;
      var labelRight = _props2.labelRight;

      return _react2['default'].createElement(
        'div',
        {
          style: this.getStyle('toggleBase', mod, style),
          onClick: function () {
            return _this.handleClick();
          } },
        this.renderSide(labelLeft, this.state.left, 'left'),
        this.renderSide(labelRight, !this.state.left, 'right'),
        this.renderKnob(this.state.left)
      );
    }
  }]);

  var _Toggle = Toggle;
  Toggle = (0, _utilsMatterBasics2['default'])(Toggle) || Toggle;
  Toggle = (0, _radium2['default'])(Toggle) || Toggle;
  return Toggle;
})(_react2['default'].Component);

exports['default'] = Toggle;
module.exports = exports['default'];
//# sourceMappingURL=Toggle.js.map