'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _reactPureRenderFunction = require('react-pure-render/function');

var _reactPureRenderFunction2 = _interopRequireDefault(_reactPureRenderFunction);

var _utilsMatterBasics = require('../../utils/MatterBasics');

var _utilsMatterBasics2 = _interopRequireDefault(_utilsMatterBasics);

var _Scrollbar = require('./Scrollbar');

var _Scrollbar2 = _interopRequireDefault(_Scrollbar);

var _lodashLangToArray = require('lodash/lang/toArray');

var _lodashLangToArray2 = _interopRequireDefault(_lodashLangToArray);

var Scrollable = (function (_React$Component) {
  _inherits(Scrollable, _React$Component);

  _createClass(Scrollable, null, [{
    key: 'propTypes',
    value: {
      verticalScroll: _react2['default'].PropTypes.number,
      onChangeVerticalScroll: _react2['default'].PropTypes.func
    },
    enumerable: true
  }]);

  function Scrollable(props) {
    var _this = this;

    _classCallCheck(this, _Scrollable);

    _get(Object.getPrototypeOf(_Scrollable.prototype), 'constructor', this).call(this, props);

    this.shouldComponentUpdate = _reactPureRenderFunction2['default'];

    this.handleVerticalScroll = function (scroll) {
      scroll = Math.max(0, Math.min(_this.getMaxVerticalScroll(), scroll));

      _this.setState({ verticalScroll: scroll });
      if (_this.props.onChangeVerticalScroll) {
        _this.props.onChangeVerticalScroll(scroll);
      }
    };

    this.handleWheel = function (e) {
      e.stopPropagation();
      e.preventDefault();
      var way = e.deltaY / 3;
      var verticalScroll = _this.state.verticalScroll;

      _this.handleVerticalScroll(verticalScroll + way);
    };

    this.setSizes = function () {
      var containerNode = _reactDom2['default'].findDOMNode(_this);
      var containerBr = containerNode.getBoundingClientRect();
      var childNodes = (0, _lodashLangToArray2['default'])(containerNode.children);
      var getHeight = function getHeight(node) {
        return node.getBoundingClientRect().height;
      };
      var contentHeight = Math.max.apply(Math, _toConsumableArray(childNodes.map(getHeight)));

      _this.setState({
        containerHeight: containerBr.height,
        contentHeight: contentHeight
      });
    };

    this.state = {
      verticalScroll: 0,
      containerHeight: 0,
      contentHeight: 0
    };
  }

  _createClass(Scrollable, [{
    key: 'getMaxVerticalScroll',
    value: function getMaxVerticalScroll() {
      var _state = this.state;
      var containerHeight = _state.containerHeight;
      var contentHeight = _state.contentHeight;

      return contentHeight - containerHeight;
    }
  }, {
    key: 'renderChildren',
    value: function renderChildren(top) {
      return _react2['default'].Children.map(this.props.children, function (child) {
        var style = _extends({}, child.props.style, { transform: 'translateY(' + top + 'px)' });
        return _react2['default'].cloneElement(child, { style: style });
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var mod = _props.mod;
      var style = _props.style;
      var _state2 = this.state;
      var containerHeight = _state2.containerHeight;
      var contentHeight = _state2.contentHeight;

      var verticalScroll = this.props.verticalScroll === undefined ? this.state.verticalScroll : this.props.verticalScroll;
      var maxVerticalScroll = this.getMaxVerticalScroll();

      return _react2['default'].createElement(
        'div',
        _extends({}, this.getBasics(verticalScroll), {
          onWheel: this.handleWheel,
          style: _extends({}, style, {
            overflow: 'hidden',
            position: 'relative',
            //the basic is stretch for display:flex but it's needs the children
            // in they original size
            alignItems: 'flex-start'
          }) }),
        this.renderChildren(-verticalScroll),
        maxVerticalScroll > 0 && _react2['default'].createElement(_Scrollbar2['default'], {
          type: 'vertical',
          scroll: verticalScroll,
          height: containerHeight,
          maxScroll: maxVerticalScroll,
          onChange: this.handleVerticalScroll })
      );
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setSizes();
      this._setSizesSetI = setInterval(this.setSizes, 312);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearInterval(this._setSizesSetI);
    }
  }]);

  var _Scrollable = Scrollable;
  Scrollable = (0, _utilsMatterBasics2['default'])(Scrollable) || Scrollable;
  Scrollable = (0, _radium2['default'])(Scrollable) || Scrollable;
  return Scrollable;
})(_react2['default'].Component);

exports['default'] = Scrollable;
module.exports = exports['default'];
//# sourceMappingURL=Scrollable.js.map