'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _customDrag = require('custom-drag');

var _customDrag2 = _interopRequireDefault(_customDrag);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _reactPureRenderFunction = require('react-pure-render/function');

var _reactPureRenderFunction2 = _interopRequireDefault(_reactPureRenderFunction);

var _utilsMatterBasics = require('../../utils/MatterBasics');

var _utilsMatterBasics2 = _interopRequireDefault(_utilsMatterBasics);

var dragOptions = {
  onDown: function onDown(props, monitor) {
    monitor.setData({
      initScroll: props.scroll
    });
  },
  onDrag: function onDrag(props, monitor) {
    var _monitor$getDifferenceFromInitialOffset = monitor.getDifferenceFromInitialOffset();

    var mouseOffset = _monitor$getDifferenceFromInitialOffset.y;
    var initScroll = monitor.data.initScroll;
    var maxScroll = props.maxScroll;
    var height = props.height;

    var offset = maxScroll / height * mouseOffset;
    var scroll = Math.max(0, Math.min(maxScroll, initScroll + offset));
    props.onChange(scroll);
  }
};

var Scrollbar = (function (_React$Component) {
  _inherits(Scrollbar, _React$Component);

  function Scrollbar() {
    _classCallCheck(this, _Scrollbar);

    _get(Object.getPrototypeOf(_Scrollbar.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(Scrollbar, [{
    key: 'getThumbStyle',
    value: function getThumbStyle() {
      var _props = this.props;
      var maxScroll = _props.maxScroll;
      var height = _props.height;
      var scroll = _props.scroll;

      var display = maxScroll > 0 ? 'hidden' : 'visible';
      var thumbHeight = Math.max(17, height * (height / (maxScroll + height))) || 0;
      var top = (height - thumbHeight) * (scroll / maxScroll) || 0;
      return { display: display, height: thumbHeight, top: top };
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props;
      var height = _props2.height;
      var scroll = _props2.scroll;
      var maxScroll = _props2.maxScroll;
      var mod = _props2.mod;
      var style = _props2.style;
      var dragRef = _props2.dragRef;

      return _react2['default'].createElement(
        'div',
        { style: this.getStyle('scrollbar', mod, style) },
        _react2['default'].createElement('div', {
          ref: dragRef,
          style: this.getStyle('scrollbarThumb', mod, this.getThumbStyle()) })
      );
    }
  }], [{
    key: 'propTypes',
    value: {
      height: _react.PropTypes.number,
      scroll: _react.PropTypes.number,
      maxScroll: _react.PropTypes.number,
      onChange: _react.PropTypes.func
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      height: 0,
      scroll: 0,
      maxScroll: 0
    },
    enumerable: true
  }]);

  var _Scrollbar = Scrollbar;
  Scrollbar = (0, _utilsMatterBasics2['default'])(Scrollbar) || Scrollbar;
  Scrollbar = (0, _radium2['default'])(Scrollbar) || Scrollbar;
  Scrollbar = (0, _customDrag2['default'])(dragOptions, function (connect) {
    return {
      dragRef: connect.getDragRef()
    };
  })(Scrollbar) || Scrollbar;
  return Scrollbar;
})(_react2['default'].Component);

exports['default'] = Scrollbar;
module.exports = exports['default'];
//# sourceMappingURL=Scrollbar.js.map