'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

exports['default'] = function (theme, mod) {

  var config = theme.getStyle('config', mod);

  var _theme$getStyle = theme.getStyle('toggleConfig', mod);

  var knobWidth = _theme$getStyle.knobWidth;
  var labelOffset = _theme$getStyle.labelOffset;

  return {
    mixins: ['font'],

    transition: 'all ' + config.anim,
    height: 0,
    paddingLeft: 12,
    paddingRight: 12,
    lineHeight: config.lineHeight + 'px',
    textAlign: 'center',
    cursor: 'default',
    opacity: 0,
    side: {
      left: {
        marginLeft: knobWidth,
        transform: 'translateX(' + labelOffset + ')'
      },
      right: {
        marginRight: knobWidth,
        transform: 'translateX(-' + labelOffset + ')'
      }
    },
    on: {
      opacity: 1,
      transform: 'translateX(0px)'
    }
  };
};

module.exports = exports['default'];
//# sourceMappingURL=toggleSide.js.map