'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _reactPureRenderFunction = require('react-pure-render/function');

var _reactPureRenderFunction2 = _interopRequireDefault(_reactPureRenderFunction);

var _customDrag = require('custom-drag');

var _customDrag2 = _interopRequireDefault(_customDrag);

var PI = Math.PI;
var PI2 = PI * 2;

function radDiff(a, b) {
  var PI = Math.PI;

  var diff = b - a;
  diff = (diff + PI) % PI * 2 - PI;
  return diff;
}

function setHue(monitor, component) {
  var _monitor$getClientOffset = monitor.getClientOffset();

  var x = _monitor$getClientOffset.x;
  var y = _monitor$getClientOffset.y;

  var _monitor$getData = monitor.getData();

  var centerX = _monitor$getData.centerX;
  var centerY = _monitor$getData.centerY;

  x -= centerX;
  y -= centerY;
  var rad = Math.atan2(y, x);
  rad = rad < 0 ? -rad : PI2 - rad;
  var h = rad / PI2;
  component.setState({ h: h });
}

function setSaturationLight(props, monitor, component) {
  var _monitor$getClientOffset2 = monitor.getClientOffset();

  var x = _monitor$getClientOffset2.x;
  var y = _monitor$getClientOffset2.y;
  var h = component.state.h;

  var _monitor$getData2 = monitor.getData();

  var centerX = _monitor$getData2.centerX;
  var centerY = _monitor$getData2.centerY;

  x -= centerX;
  y -= centerY;
  var dist = Math.sqrt(x * x + y * y);
  var baseRad = -h * PI2;
  var mouseRad = Math.atan2(y, x);
  var diffRad = mouseRad - baseRad; //radDiff(baseRad, mouseRad)
  x = dist * Math.cos(diffRad);
  y = dist * Math.sin(diffRad);
  var innerRadius = props.radius - props.width;
  var smallAltitude = Math.sin(Math.PI / 6) * innerRadius;
  var edge = Math.sqrt(Math.pow(innerRadius, 2) - Math.pow(smallAltitude, 2)) * 2;
  var altitude = innerRadius + smallAltitude;

  var saturation = (x + smallAltitude) / altitude;
  var lightRange = edge * (1 - saturation);
  var lightness = y / lightRange + 0.5;

  component.setState({
    l: Math.max(0, Math.min(1, lightness)),
    s: Math.max(0, Math.min(1, saturation))
  });
}

var customDragOptions = {
  onDown: function onDown(props, monitor, component) {
    var radius = props.radius;
    var width = props.width;

    var clientOffset = monitor.getClientOffset();
    var sourceClientOffset = monitor.getSourceClientOffset();
    var left = clientOffset.x - sourceClientOffset.x;
    var top = clientOffset.y - sourceClientOffset.y;
    var centerX = left + radius;
    var centerY = top + radius;
    var x = clientOffset.x - centerX;
    var y = clientOffset.y - centerY;
    var distanceFromCenter = Math.sqrt(Math.pow(x, 2) + Math.pow(y, 2));
    var edit = undefined;

    if (distanceFromCenter < radius) {
      edit = distanceFromCenter > radius - width ? 'h' : 'sv';
    }

    if (!edit) {
      //bail dragging
      return false;
    }

    component.setState({ focus: true });

    monitor.setData({
      edit: edit,
      centerX: centerX,
      centerY: centerY
    });

    if (edit === 'h') {
      setHue(monitor, component);
    } else {
      setSaturationLight(props, monitor, component);
    }
  },

  onDrag: function onDrag(props, monitor, component) {
    // var deg = getMouseDeg(monitor)

    var _monitor$getData3 = monitor.getData();

    var edit = _monitor$getData3.edit;

    if (edit === 'h') {
      setHue(monitor, component);
    } else {
      setSaturationLight(props, monitor, component);
    }
  },

  onUp: function onUp(props, monitor, component) {
    component.setState({
      h: props.h,
      s: props.s,
      l: props.l,
      focus: false
    });
  }
};

var ColorCircle = (function (_React$Component) {
  _inherits(ColorCircle, _React$Component);

  _createClass(ColorCircle, null, [{
    key: 'propsTypes',
    value: {
      radius: _react.PropTypes.number,
      width: _react.PropTypes.number,
      h: _react.PropTypes.number,
      s: _react.PropTypes.number,
      l: _react.PropTypes.number,
      onChange: _react.PropTypes.func
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      radius: 134,
      width: 32,
      h: 0,
      s: 0.5,
      l: 0.5
    },
    enumerable: true
  }]);

  function ColorCircle(props) {
    _classCallCheck(this, _ColorCircle);

    _get(Object.getPrototypeOf(_ColorCircle.prototype), 'constructor', this).call(this, props);

    this.shouldComponentUpdate = _reactPureRenderFunction2['default'];
    this.state = {
      h: this.props.h,
      s: this.props.s,
      l: this.props.l
    };
  }

  _createClass(ColorCircle, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.renderRange();
      this.renderTri();
      this.renderShadow();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (!this.state.focus) {
        this.setState({
          h: nextProps.h,
          s: nextProps.s,
          l: nextProps.l
        });
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      var _props = this.props;
      var radius = _props.radius;
      var width = _props.width;

      if (prevProps.radius !== radius || prevProps.width !== width) {

        this.renderRange();
        this.renderShadow();
      }

      this.renderTri();

      var hslChanged = function hslChanged(a, b) {
        return a.h !== b.h || a.s !== b.s || a.l !== b.l;
      };

      if (hslChanged(this.state, prevState) && hslChanged(this.state, this.props) && this.props.onChange) {
        this.props.onChange({
          h: this.state.h,
          s: this.state.s,
          l: this.state.l
        });
      }
    }
  }, {
    key: 'renderRange',
    value: function renderRange() {
      function getChannel(stops, _v) {

        var p = _v * 6 % 1,
            posA = parseInt(_v * 6),
            posB = (posA + 1) % 6,
            pos = stops[posA] + (stops[posB] - stops[posA]) * p;

        return parseInt(pos * 256);
      }
      var getR = getChannel.bind(null, [1, 1, 0, 0, 0, 1, 1]);
      var getG = getChannel.bind(null, [0, 0, 0, 1, 1, 1, 0]);
      var getB = getChannel.bind(null, [0, 1, 1, 1, 0, 0, 0]);

      var canvas = _reactDom2['default'].findDOMNode(this.refs.range),
          ctx = canvas.getContext('2d'),
          r0 = this.props.radius - this.props.width,
          r1 = this.props.radius,
          step = PI2 / (2 * r1 * PI);

      canvas.width = r1 * 2;
      canvas.height = r1 * 2;

      ctx.translate(r1, r1);
      ctx.lineWidth = 2;

      for (var rad = 0; rad < PI2; rad += step) {

        var v = rad / PI2;
        var color = 'rgb(' + getR(v) + ',' + getG(v) + ',' + getB(v) + ')';

        ctx.beginPath();
        ctx.strokeStyle = color;
        ctx.moveTo(Math.cos(rad) * r0, Math.sin(rad) * r0);
        ctx.lineTo(Math.cos(rad) * r1, Math.sin(rad) * r1);
        ctx.stroke();
      }
    }
  }, {
    key: 'renderTri',
    value: function renderTri() {
      var canvas = _reactDom2['default'].findDOMNode(this.refs.tri);
      var ctx = canvas.getContext('2d');
      var r0 = this.props.radius - this.props.width;
      var r1 = this.props.radius;
      var h = this.state.h;

      canvas.width = r1 * 2;
      canvas.height = r1 * 2;
      ctx.translate(r1, r1);
      ctx.moveTo(Math.cos(-PI2 / 3) * r0, Math.sin(-PI2 / 3) * r0);
      ctx.lineTo(Math.cos(0) * r0, Math.sin(0) * r0);
      ctx.lineTo(Math.cos(PI2 / 3) * r0, Math.sin(PI2 / 3) * r0);
      ctx.closePath();
      ctx.fillStyle = 'hsl(' + h * 360 + ',100%,50%)';
      ctx.fill();
    }
  }, {
    key: 'renderShadow',
    value: function renderShadow() {
      var canvas = _reactDom2['default'].findDOMNode(this.refs.shadow);
      var ctx = canvas.getContext('2d');
      var _props2 = this.props;
      var radius = _props2.radius;
      var width = _props2.width;

      var innerRadius = radius - width;
      var a = {
        x: Math.cos(-PI2 / 3) * innerRadius,
        y: Math.sin(-PI2 / 3) * innerRadius
      };
      var b = {
        x: Math.cos(0) * innerRadius,
        y: Math.sin(0) * innerRadius
      };
      var c = {
        x: Math.cos(PI2 / 3) * innerRadius,
        y: Math.sin(PI2 / 3) * innerRadius
      };
      var triangleHeight = c.y - a.y;
      var triangleWidth = b.x - a.x;

      canvas.width = radius * 2;
      canvas.height = radius * 2;
      ctx.translate(radius + a.x, radius + a.y);
      for (var i = 0; i < triangleWidth; i += 1) {
        var pos = i / triangleWidth;
        var alpha = 1 - pos;
        var gap = triangleHeight * pos / 2;
        var grd = ctx.createLinearGradient(0, gap, 0, triangleHeight - gap);
        grd.addColorStop(0, 'rgba(255, 255, 255, ' + alpha + ')');
        grd.addColorStop(1, 'rgba(0, 0, 0, ' + alpha + ')');

        ctx.beginPath();
        ctx.moveTo(i - 0.5, gap);
        ctx.lineTo(i - 0.5, triangleHeight - gap + 0.23);
        ctx.strokeStyle = grd;
        ctx.stroke();
        ctx.closePath();
      }
    }
  }, {
    key: 'renderControlls',
    value: function renderControlls() {
      var _props3 = this.props;
      var radius = _props3.radius;
      var width = _props3.width;
      var _state = this.state;
      var h = _state.h;
      var s = _state.s;
      var l = _state.l;

      var rad = -h * PI2;
      var innerRadius = radius - width;
      var smallAltitude = Math.sin(PI / 6) * innerRadius;
      var edge = Math.sqrt(Math.pow(innerRadius, 2) - Math.pow(smallAltitude, 2)) * 2;
      var altitude = innerRadius + smallAltitude;
      var cx = altitude * s - smallAltitude;
      var cy = edge * (s - 1) * (l - 0.5);
      var cRad = Math.atan2(cy, cx) - rad;
      var cDist = Math.sqrt(Math.pow(cx, 2) + Math.pow(cy, 2));
      cx = radius + Math.cos(cRad) * cDist;
      cy = radius - Math.sin(cRad) * cDist;

      return _react2['default'].createElement(
        'svg',
        { style: {
            position: 'absolute',
            left: 0,
            overflow: 'visible',
            pointerEvents: 'none'
          } },
        _react2['default'].createElement('circle', {
          r: 6,
          cx: cx,
          cy: cy,
          fill: 'none',
          stroke: '#fff',
          strokeWidth: 2 }),
        _react2['default'].createElement('line', {
          x1: radius + Math.cos(rad) * innerRadius,
          y1: radius + Math.sin(rad) * innerRadius,
          x2: radius + Math.cos(rad) * radius,
          y2: radius + Math.sin(rad) * radius,
          stroke: '#fff',
          strokeWidth: 2 })
      );
    }
  }, {
    key: 'renderTriangle',
    value: function renderTriangle() {
      var radius = this.props.radius;
      var h = this.state.h;

      var rotate = 'rotate(' + -h * 360 + 'deg)';

      return _react2['default'].createElement(
        'div',
        { style: {
            position: 'absolute',
            width: radius * 2,
            height: radius * 2,
            left: 0,
            top: 0,
            transform: rotate } },
        _react2['default'].createElement('canvas', { ref: 'tri', style: { position: 'absolute', left: 0 } }),
        _react2['default'].createElement('canvas', { ref: 'shadow', style: { position: 'absolute', left: 0 } })
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props4 = this.props;
      var draggerRef = _props4.draggerRef;
      var style = _props4.style;

      return _react2['default'].createElement(
        'div',
        { ref: draggerRef, style: style },
        _react2['default'].createElement('canvas', { ref: 'range' }),
        this.renderTriangle(),
        this.renderControlls()
      );
    }
  }]);

  var _ColorCircle = ColorCircle;
  ColorCircle = (0, _customDrag2['default'])(customDragOptions)(ColorCircle) || ColorCircle;
  return ColorCircle;
})(_react2['default'].Component);

exports['default'] = ColorCircle;
module.exports = exports['default'];
//# sourceMappingURL=ColorCircle.js.map