'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _ClickAway = require('./ClickAway');

var _ClickAway2 = _interopRequireDefault(_ClickAway);

var _componentsList = require('../components/List');

var _componentsList2 = _interopRequireDefault(_componentsList);

var _componentsPanel = require('../components/Panel');

var _componentsPanel2 = _interopRequireDefault(_componentsPanel);

var _flyer = require('./flyer');

var _flyer2 = _interopRequireDefault(_flyer);

var ContextMenu = (function (_React$Component) {
  _inherits(ContextMenu, _React$Component);

  function ContextMenu() {
    var _this = this;

    _classCallCheck(this, ContextMenu);

    _get(Object.getPrototypeOf(ContextMenu.prototype), 'constructor', this).apply(this, arguments);

    this.handleContextMenu = function (e) {
      e.preventDefault();

      if (_this.mountNode) {
        _this.hide();
      } else {
        _this.show(e.clientX, e.clientY);
      }
    };

    this.handleClickAway = function () {
      _this.hide();
    };
  }

  _createClass(ContextMenu, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var node = _reactDom2['default'].findDOMNode(this);
      var triggerEvent = this.props.triggerEvent;

      node.addEventListener(triggerEvent, this.handleContextMenu);
      this.dispose = function () {
        node.removeEventListener(triggerEvent, _this2.handleContextMenu);
      };
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.dispose();
    }
  }, {
    key: 'show',
    value: function show(x, y) {
      var _this3 = this;

      this.hide();
      this.disposeLast = (0, _flyer2['default'])({
        x: x,
        y: y,
        renderElement: function renderElement() {
          return _this3.renderContextMenu();
        }
      });
    }
  }, {
    key: 'hide',
    value: function hide() {
      if (this.disposeLast) {
        this.disposeLast();
        this.disposeLast = undefined;
      }
    }
  }, {
    key: 'renderContextMenu',
    value: function renderContextMenu() {
      var _this4 = this;

      var renderContent = this.props.renderContent;

      return _react2['default'].createElement(
        _ClickAway2['default'],
        { onClickAway: this.handleClickAway },
        renderContent(this.props, function () {
          return _this4.hide();
        })
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return this.props.children;
    }
  }], [{
    key: 'propTypes',
    value: {
      children: _react.PropTypes.element.isRequired,
      items: _react.PropTypes.arrayOf(_react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.object])),
      triggerEvent: _react.PropTypes.string,
      renderContent: _react.PropTypes.func
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      triggerEvent: 'contextmenu',
      renderContent: function renderContent(props, hide) {
        var items = (props.items || []).map(function (item) {
          var originalClickHandler = item.onClick;
          if (typeof item === 'string') {
            item = { label: item };
          }
          return _extends({}, item, {
            onClick: function onClick() {
              if (originalClickHandler) {
                originalClickHandler();
              }
              hide();
            }
          });
        });

        return _react2['default'].createElement(
          _componentsPanel2['default'],
          null,
          _react2['default'].createElement(_componentsList2['default'], { items: items })
        );
      }
    },
    enumerable: true
  }]);

  return ContextMenu;
})(_react2['default'].Component);

exports['default'] = ContextMenu;
module.exports = exports['default'];
//# sourceMappingURL=ContextMenu.js.map