'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _themeGetTheme = require('../theme/getTheme');

var _themeGetTheme2 = _interopRequireDefault(_themeGetTheme);

var _lodashObjectForOwn = require('lodash/object/forOwn');

var _lodashObjectForOwn2 = _interopRequireDefault(_lodashObjectForOwn);

var _lodashObjectPick = require('lodash/object/pick');

var _lodashObjectPick2 = _interopRequireDefault(_lodashObjectPick);

exports['default'] = function (Component) {
  Component.contextTypes = {
    matterkitTheme: _react2['default'].PropTypes.object
  };

  Component.prototype.getBasics = function () {
    return (0, _lodashObjectPick2['default'])(this.props, 'id', 'className', 'onClick', 'onMouseEnter', 'onMouseLeave', 'onMouseOver', 'onMouseOut', 'onMouseDown', 'onMouseUp');
  };

  Component.prototype.getStyle = function (name, mod, style) {
    var styles = (0, _themeGetTheme2['default'])(this);
    var ret = styles.getStyle(name, mod, style);

    (0, _lodashObjectForOwn2['default'])(ret, function (value, key) {
      var pre = key[0];
      if (pre !== ':' && pre !== '@' && typeof value === 'object') {
        delete ret[key];
      }
    });

    return ret;
  };
};

module.exports = exports['default'];
//# sourceMappingURL=MatterBasics.js.map