'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = flyer;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

function flyer(_ref) {
  var x = _ref.x;
  var y = _ref.y;
  var renderElement = _ref.renderElement;
  var wrapperStyle = _ref.wrapperStyle;

  var mountNode = document.createElement('div');
  mountNode.style.position = 'fixed';
  mountNode.style.left = x + 'px';
  mountNode.style.top = y + 'px';

  if (wrapperStyle) {
    Object.keys(wrapperStyle).forEach(function (name) {
      mountNode.style[name] = wrapperStyle[name];
    });
  }

  document.body.appendChild(mountNode);
  _reactDom2['default'].render(renderElement(), mountNode);

  return function () {
    _reactDom2['default'].unmountComponentAtNode(mountNode);
    var parentNode = mountNode && mountNode.parentNode;
    if (parentNode) {
      parentNode.removeChild(mountNode);
    }
  };
}

// show = () => {
//   var domNode = React.findDOMNode(this)
//   var parent = domNode.parentNode
//   var br = parent.getBoundingClientRect()
//
//   this.setState({
//     show: true,
//     style: {
//       left: br.left - this.props.width - 5,
//       top: br.top,
//     }
//   })
// }
//
// hide = () => {
//   clearTimeout(this._showSetT)
//   this.setState({show: false})
// }
//
// componentDidMount() {
//   this.targetNode = React.findDOMNode(this).parentNode
//   this.targetNode.addEventListener('mouseover', this.showDelayed)
//   this.targetNode.addEventListener('mouseleave', this.hide)
// }
//
// componentWillUnmount() {
//   this.targetNode.removeEventListener('mouseover', this.showDelayed)
//   this.targetNode.removeEventListener('mouseleave', this.hide)
// }
//
// componentDidUpdate() {
//   this.placeContent()
// }
//
// placeContent() {
//   var {place} = this.props
//   var full = {
//     top: 0,
//     left: 0,
//     width: window.innerWidth,
//     height: window.innerHeight
//   }
//   full.right = full.width
//   full.bottom = full.height
//   var target = this.targetNode.getBoundingClientRect()
//   var content = React.findDOMNode(this).getBoundingClientRect()
//   var position = {}
//
//   changePlaceIfNeeded()
//
//   if (isPlaceVertical()) {
//     if (place === 'left') {
//       position.left = target.left - content.width
//     }
//     else {
//       position.left = target.right
//     }
//     position.top = target.top + ((target.height - content.height) / 2)
//   }
//   else {
//     if (place === 'top') {
//       position.top = target.top - content.height
//     }
//     else {
//       position.top = target.bottom
//     }
//     position.left = target.left + ((target.width - content.width) / 2)
//   }
//
//   this.setState({position})
//
//   function changePlaceIfNeeded() {
//     var oppositePlace = getOppositePlace()
//     var space = target[palce] - full[palce]
//     var oppositeSpace = target[oppositePalce] - full[oppositePalce]
//     var size = isPlaceVertical() ? content.width : content.height
//
//     if (space < size && space < oppositeSpace) {
//       place = oppositePalce
//     }
//   }
//
//   function getOppositePlace() {
//     switch (place) {
//       case 'top': return 'bottom'
//       case 'bottom': return 'top'
//       case 'left': return 'right'
//       case 'right': return 'left'
//     }
//   }
//
//   function isPlaceVertical() {
//     return place === 'left' || place === 'right'
//   }
// }
module.exports = exports['default'];
//# sourceMappingURL=flyer.js.map